<template>
  <div class="file-upload">
    <form enctype="multipart/form-data" novalidate v-if="isInitial || isSaving">
      <div class="dropbox">
        <input type="file" :name="uploadFieldName" :disabled="isSaving" @change="handleFileUpload({ fieldName: $event.target.name, fileList: $event.target.files })" accept="image/*" class="input-file">
          <p v-if="isInitial">
            Drag your file here to begin<br> or click to browse
          </p>
          <p v-if="isSaving">
            Uploading {{ fileCount }} files...
          </p>
      </div>
    </form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

const STATUS_INITIAL = 0, STATUS_SAVING = 1, STATUS_SUCCESS = 2, STATUS_FAILED = 3;

export default {
  name: 'file-upload',
  data() {
    return {
      uploadedFiles: [],
      uploadError: null,
      currentStatus: null,
      uploadFieldName: 'file'
    }
  },
  computed: {
    isInitial() {
      return this.currentStatus === STATUS_INITIAL;
    },
    isSaving() {
      return this.currentStatus === STATUS_SAVING;
    },
    isSuccess() {
      return this.currentStatus === STATUS_SUCCESS;
    },
    isFailed() {
      return this.currentStatus === STATUS_FAILED;
    }
  },
  methods: {
    ...mapActions(['handleFileUpload']),
    reset() {
      // reset form to initial state
      this.currentStatus = STATUS_INITIAL;
      this.uploadedFiles = [];
      this.uploadError = null;
    },
    save(formData) {
      // upload data to the server
      this.currentStatus = STATUS_SAVING;

      upload(formData)
        .then(x => {
          this.uploadedFiles = [].concat(x);
          this.currentStatus = STATUS_SUCCESS;
          console.log(x)
        })
        .catch(err => {
          this.uploadError = err.response;
          this.currentStatus = STATUS_FAILED;
        });
    }
  },
  mounted() {
    this.reset();
  },
}
</script>

<style lang="scss" scoped>
@import '../config.scss';

.file-upload {
  max-width: 400px;
  margin: 0 auto;
}

.dropbox {
  outline: 1px dashed $orange;
  outline-offset: -10px;
  background-color: $light-grey;
  color: $dark-grey;
  padding: 10px 10px;
  min-height: 100px;
  width: 100%;
  position: relative;
  cursor: pointer;
  border-radius: 8px;
  display: flex;
  align-items: center;
  justify-content: center;
}

.input-file {
  opacity: 0;
  width: 100%;
  height: 100%;
  position: absolute;
  cursor: pointer;
}

.dropbox:hover {
  background: rgba($light-grey, 0.8);
}

.dropbox p {
  text-align: center;
  color: $dark-grey;
}
</style>
